from typing import List
# import codecs

# Procesar el fichero por líneas:
# 1. Mostrar en el output.
# 2. Copiar en otro fichero.
# 3. Guardar su contenido en una lista.

def mostrar (nombreFichero : str) -> None:
  """
  EFECTO: Muestra en la pantalla el contenido de un fichero con 
          nombre <nombreFichero> línea a línea.
  """ 
  fichero = open(nombreFichero)
  linea = fichero.readline()
  while linea != "":
    print(linea, end="")
    linea = fichero.readline()
  fichero.close()

def mostrarConWith (nombreFichero : str) -> None:
  with open(nombreFichero) as fichero:
    linea = fichero.readline()
    while linea != "":
      print(linea, end="")
      linea = fichero.readline()
  fichero.close()
	
def mostrarConFor (nombreFichero : str) -> None:
  fichero = open(nombreFichero)
  for linea in fichero:
    # 1. Ver qué pasa.
	# print(linea)
	# 2. Con el for no hay que usar readline().
	#    El print escribe y avanza al siguiente
    # linea = fichero.readline()  
    print(linea, end="")
  fichero.close()

def copiar (nombreIn, nombreOut : str) -> None:
  """
  EFECTO: Copia el contenido de un fichero de nombre 
          <nombreIn> en otro fichero de nombre <nombreOut>
		  línea a línea.
  """ 
  entrada = open(nombreIn)
  salida = open(nombreOut, "w")
  entrada.readline()
  linea = entrada.readline()
  while linea != "":
    print(linea, file=salida)
    # salida.write(linea)
    linea = entrada.readline()
  entrada.close()
  salida.close()

def cargar (nombreFichero : str) -> List[str]:
  fichero = open(nombreFichero)
  lista = []
  linea = fichero.readline()
  while linea != "":
    lista += [linea]
    linea = fichero.readline()
  fichero.close()
  return lista

def cargarUnaTacada (nombreFichero : str) -> List[str]:
  fichero = open(nombreFichero)
  lista = fichero.readlines()
  fichero.close()
  return lista

# Procesar el fichero por caracteres:
# 1. Mostrar en el output.
# 2. Copiar en otro fichero.

def mostrarCarACar (nombre : str) -> None:
  """
  EFECTO: Muestra en la pantalla el contenido de un fichero de 
          nombre <nombreFichero> carácter a carácter, separando 
		  cada carácter con un espacio.
  """ 
  fichero = open(nombre)
  c = fichero.read(1)
  while c != "":
    print(c, end=" ")
    c = fichero.read(1)
  fichero.close()

def copiarCarACar (nombreIn, nombreOut : str) -> None:
  """
  EFECTO: Copia el contenido de un fichero de nombre 
          <nombreIn> en otro fichero de nombre <nombreOut>
		  carácter a carácter.
  """ 
  entrada = open(nombreIn)
  salida = open(nombreOut, "w")
  c = entrada.read(1)
  while c != "":
    salida.write(c)
    c = entrada.read(1)
  entrada.close()
  salida.close()

# Procesar el fichero de un golpe:
def copiarDeUnaTacada(nombreIn, nombreOut : str) -> None:
  entrada = open(nombreIn)
  salida = open(nombreOut, "w")
  todo = entrada.read()
  salida.write(todo)
  entrada.close()
  salida.close()

# Ejercicios:

def main ():
  # 1.
  # mostrar("nombresHistoricos.txt")
  # 2.
  # mostrarConWith("nombresHistoricos.txt")
  # 3.
  # mostrarConFor("nombresHistoricos.txt")
  # 4.
  # listaDeNombres = cargar("nombresHistoricos.txt")
  # listaDeNombres = cargarUnaTacada("nombresHistoricos.txt")
  print(listaDeNombres, sep=" ")
  # 5.
  # copiar("nombresHistoricos.txt", "nombresHCopia.txt")
  # 6.
  # mostrarCarACar("nombresHistoricos.txt")
  # 7.
  # copiarCarACar("nombresHistoricos.txt", "nombresHCopiaCaC.txt")
  # copiarDeUnaTacada("nombresHistoricos.txt", "nombresHCopiaUnaTacada.txt")
  
if __name__ == '__main__': 
  main()